namespace Utilities.PPCEmulatorFileSender
{
	/// <summary>
	/// Handles the callbacks for copying files to the pocket pc emulator
	/// </summary>
	class ProgressCallback: Microsoft.VisualStudio.DeviceConnectivity.ICallback
	{
		#region Variables
		private MainForm form;
		#endregion

		#region Constructor
		public ProgressCallback(MainForm form)
		{
			this.form = form;
		}
		#endregion

		#region Interface Methods
		public virtual bool ReportDownloadAction(Microsoft.VisualStudio.DeviceConnectivity.DOWNLOAD_ACTION action, uint hResult, string szLocalPath, string szRemotePath, ulong dwSize)
		{
			if (action == (Microsoft.VisualStudio.DeviceConnectivity.DOWNLOAD_ACTION)3)
			{
				System.IO.FileInfo fileInfo = new System.IO.FileInfo(szLocalPath);
				int percentage = (int)((100 * (long)dwSize) / fileInfo.Length);
				form.Update(percentage);
			}
			return true;
		}

		public virtual bool ReportConnectionAction(Microsoft.VisualStudio.DeviceConnectivity.CONNECTION_ACTION action, uint hResult, string szServer)
		{
			return false;
		}
		#endregion
	}

}

